class PriorityQueue {
    constructor(less) {
        this.less = less;
        this.heap = [];
    }
    push(x) {
        let j = this.heap.length;
        while(j) {
            let i = (j-1)>>1;
            if(this.less(this.heap[i], x)) break;
            this.heap[j] = this.heap[i];
            j = i;
        }
        this.heap[j] = x;
    }
    pop() {
        switch(this.heap.length) {
        case 0: return null;
        case 1: return this.heap.pop();
        }
        let retv = this.heap[0],
            x = this.heap.pop(),
            i = 0;
        while(true) {
            let j = 2*i+1;
            if(j>=this.heap.length) break;
            if(j+1<this.heap.length)
                if(this.less(this.heap[j+1], this.heap[j])) j++;
            if(this.less(x, this.heap[j])) break;
            this.heap[i] = this.heap[j];
            i = j;
        }
        this.heap[i] = x;
        return retv;
    }
}

module.exports = PriorityQueue;
