function output(step) {
    let width = step.reduce((a, b) => Math.max(a, b.TYPE.length), 0),
        space = String(step.length).length+2,
        _step = []
    for(let i=0; i<step.length; i++)
        _step[i] = [
            `#${1+i}:`.padStart(space),
            step[i].TYPE.padEnd(width),
            step[i].reason
        ]
    return _step;
}

function answer(premise, cl) {
    let history = {},
        step = []
    function _answer(cl) {
        if(history[cl.TYPE]!==undefined) return;
        let reason;
        switch(cl.ATOM) {
        case 'axiom 0':
            reason = 'theorem';
            break;
        case 'axiom 1':
        case 'axiom 2':
            reason = cl.ATOM;
            break;
        case 'FV':
            switch(premise[cl.TYPE].op) {
            case 'axiom 3':
            case 'axiom 4':
            case 'axiom 5':
            case 'axiom 6':
            case 'axiom 7':
            case 'axiom 8':
            case 'axiom 9':
            case 'axiom 10':
                reason = premise[cl.TYPE].op;
                break;
            default:
                reason = 'premise';
            }
            break;
        default:
            _answer(cl.right);
            _answer(cl.left);
            let p1 = '#'+(1+history[cl.right.TYPE]),
                p2 = '#'+(1+history[cl.left.TYPE]),
                p3 = '#'+(1+step.length);
            reason = p2+'='+p1+'->'+p3;
//          step[history[cl.left.TYPE]].TYPE = p1+'->'+p3;
        }
        history[cl.TYPE] = step.length;
        step.push({TYPE: cl.TYPE, reason});
    }
    _answer(cl);
    return output(step);
}

module.exports = answer;
