// Propositional logic Grammar

{
  function L2R(result, element) {
    return {
      op: element[1],
      left: result,
      right: element[3]
    }
  }
}

Expr
  = _ premise:Premise? _ "|-" _ conclusion:Imply _ {
    return {
      premise: premise || [],
      conclusion
    }
  }

Premise
  = first:Imply other:(_ "," _ Imply)* {
    let premise = [first];
    for(let i=0; i<other.length; i++)
        premise.push(other[i][3]);
    return premise;
  }

Imply
  = or:Or imply:(_ "->" _ Or)* {
    return imply.reduce(L2R, or)
  }

Or
  = and:And or:(_ "+" _ And)* {
    return or.reduce(L2R, and)
  }

And
  = atom:Atom and:(_ "*" _ Atom)* {
    return and.reduce(L2R, atom)
  }

Atom
  = [A-Z]
  / "(" _ imply:Imply _ ")" {
    return imply
  }

_ "whitespace"
  = [ \t\n\r]*
