#!/usr/bin/env node

if(process.argv.length < 3) {
    console.log(
`
Usage: node main.js "<Proposition>"

BNF of Proposition:
    <Proposition>::= <Premise>? "|-" <Imply>
    <Premise>    ::= <Imply> ("," <Imply>)*
    <Imply>      ::= <Or> ("->" <Or>)*
    <Or>         ::= <And> ("+" <And>)*
    <And>        ::= <Atom> ("*" <Atom>)*
    <Atom>       ::= [A-Z] | "(" <Imply> ")"

Axiom of Primal:
    1) (A->(B->A))
    2) ((A->(B->C))->((A->B)->(A->C)))

Axiom of Minimal:
    3) ((A*B)->A)
    4) ((A*B)->B)
    5) (A->(B->(A*B)))
    6) (A->(A+B))
    7) (B->(A+B))
    8) ((A->C)->((B->C)->((A+B)->C)))

Axiom of Intuitionistic:
    9) (F->A)

Axiom of Classical:
   10) (((A->F)->A)->A)

Theorem:
    |- (A->A)

Rule of Inference:
     A, A->B
    ---------
        B
`
    );
    process.exit(0);
}

const prove = require('./prove');

let step = prove(process.argv[2]);
if(step instanceof Array)
    for(let i=0; i<step.length; i++)
        console.log(step[i].join(' '));
else
    console.error(step);
