const grammar = require('./grammar+');
const deduce  = require('./deduce');
const lamda   = require('./lamda');
const iks     = require('./combinator');
const answer  = require('./answer');

function prove(proposition) {
    try {
        let expr = grammar.parse(proposition),
            premise = {}
        for(let i=0; i<expr.premise.length; i++)
            premise[grammar.stringify(expr.premise[i])] = expr.premise[i];
        let proof = deduce({
            priority: [0, 0, 0, 0],
            premise,
            used: {},
            conclusion: expr.conclusion,
            lamda: null,
            apply: null
        });
        if(!proof) throw new Error('not true');
        let cl = iks(lamda.lamda(proof.lamda, proof.apply));
        return answer(proof.premise, cl);
    }
    catch(e) {
        return e instanceof grammar.SyntaxError
             ? e.message+' '+JSON.stringify(e.location.start)
             : e.message;
    }
}

module.exports = prove;
